"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TieringResult(ProtocolElement):
    """
    Represents the results of a tiering process and its input patient
    data. TieringResult     is simply a more specific, less ambiguous
    term for "cohort".     We cannot use the InterpretationRequestRD
    structure because there may be many interpretation     requests
    for the same tiering results.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "bams",
        "internalStudyId",
        "pedigree",
        "tieredVariants",
        "tieringVersion",
        "vcfs",
        "versionControl",
        "workspace",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "annotationFile": reports_4_2_0.File,
            "bams": reports_4_2_0.File,
            "bigWigs": reports_4_2_0.File,
            "otherFamilyHistory": reports_4_2_0.OtherFamilyHistory,
            "otherFiles": reports_4_2_0.File,
            "pedigree": participant_1_0_3.Pedigree,
            "pedigreeDiagram": reports_4_2_0.File,
            "tieredVariants": reports_4_2_0.ReportedVariant,
            "vcfs": reports_4_2_0.File,
            "versionControl": reports_4_2_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "complexGeneticPhenomena": reports_4_2_0.ComplexGeneticPhenomena,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.ComplexGeneticPhenomena": reports_4_2_0.ComplexGeneticPhenomena,
            "org.gel.models.report.avro.OtherFamilyHistory": reports_4_2_0.OtherFamilyHistory,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.participant.avro.Pedigree": participant_1_0_3.Pedigree,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.ReportedVariant": reports_4_2_0.ReportedVariant,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.ReportVersionControl": reports_4_2_0.ReportVersionControl,
            "org.gel.models.report.avro.TieringResult": reports_4_2_0.TieringResult,
        }

    __slots__ = [
        "bams",
        "internalStudyId",
        "pedigree",
        "tieredVariants",
        "tieringVersion",
        "vcfs",
        "versionControl",
        "workspace",
        "additionalInfo",
        "annotationFile",
        "bigWigs",
        "cellbaseVersion",
        "complexGeneticPhenomena",
        "genePanelsCoverage",
        "genomeAssemblyVersion",
        "otherFamilyHistory",
        "otherFiles",
        "pedigreeDiagram",
    ]

    def __init__(
        self,
        bams,
        internalStudyId,
        pedigree,
        tieredVariants,
        tieringVersion,
        vcfs,
        versionControl,
        workspace,
        additionalInfo=None,
        annotationFile=None,
        bigWigs=None,
        cellbaseVersion="4.0",
        complexGeneticPhenomena=None,
        genePanelsCoverage=None,
        genomeAssemblyVersion="GRCh37.p13",
        otherFamilyHistory=None,
        otherFiles=None,
        pedigreeDiagram=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.TieringResult model.

        :param bams:
            BAMs Files
        :type bams: list[File]
        :param internalStudyId:
            Internal Study id
        :type internalStudyId: str
        :param pedigree:
            Pedigree
        :type pedigree: Pedigree
        :param tieredVariants:
            Tiered Variants
        :type tieredVariants: list[ReportedVariant]
        :param tieringVersion:
            Tiering Version
        :type tieringVersion: str
        :param vcfs:
            VCFs Files where SVs and CNVs are represented
        :type vcfs: list[File]
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param workspace:
            The genome shall be assigned to the             workspaces(projects or
            domains with a predefined set of users) to control user
            access
        :type workspace: list[str]
        :param additionalInfo:
            Additional information
        :type additionalInfo: None | dict[str, str]
        :param annotationFile:
            Variant Annotation using cellbase
        :type annotationFile: None | File
        :param bigWigs:
            BigWig Files
        :type bigWigs: None | list[File]
        :param cellbaseVersion:
            Cellbase version
        :type cellbaseVersion: str
        :param complexGeneticPhenomena:
            Complex Genetic Phenomena
        :type complexGeneticPhenomena: None | ComplexGeneticPhenomena
        :param genePanelsCoverage:
            This map of key: panel_name, value: (map of key: gene, value: (map of
            metrics of key: metric name, value: float))
            That is: a map of tables of genes and metrics
        :type genePanelsCoverage: None | dict[str, dict[str, dict[str, float]]]
        :param genomeAssemblyVersion:
            This is the version of the assembly used to align the reads
        :type genomeAssemblyVersion: str
        :param otherFamilyHistory:
            It is paternal or maternal with reference to the participant.
        :type otherFamilyHistory: None | OtherFamilyHistory
        :param otherFiles:
            Other files that may be vendor specific             map of key: type
            of file, value: record of type File
        :type otherFiles: None | dict[str, File]
        :param pedigreeDiagram:
            Pedigree Diagram Files as an SGV
        :type pedigreeDiagram: None | File
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
